﻿using System;
using System.Collections.Generic;
using System.Linq;

using Npgsql;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            string sql = @"
SELECT *
FROM   COM_CODE_GROUP
WHERE  ID = '5A9E697A-A154-4F21-85D6-258E457AF8DF';

SELECT *
FROM   COM_CODE
WHERE  GROUP_ID = '5A9E697A-A154-4F21-85D6-258E457AF8DF';
";

            string connectionString = @"Host=127.0.0.1;Port=5432;Database=arca;User ID=postgres;Password=postgres";

            CodeGroupModel  codeGroup = null;
            List<CodeModel> codeList  = null;

            using(NpgsqlConnection connection = new NpgsqlConnection(connectionString))
            {
                var reader = connection.QueryMultiple(sql);

                using(reader)
                {
                    codeGroup = reader.ReadFirstOrDefault<CodeGroupModel>();

                    codeList = reader.Read<CodeModel>().ToList();
                }
            }

            if(codeGroup != null)
            {
                Console.WriteLine("CODE GROUP NAME : {0}", codeGroup.NAME);
            }

            if(codeList != null && codeList.Count > 0)
            {
                foreach(CodeModel code in codeList)
                {
                    Console.WriteLine("    {0}", code.NAME);
                }
            }
        }

        #endregion
    }
}